/****************************************/
/*	AVR ATmega8 Zeitscheiben            */
/*--------------------------------------*/
 
//----------------------------------------------------------
#include <avr/io.h> 			
#include <avr/interrupt.h>  
#include "Application.h"
#include "rfm12.h"
//----------------------------------------------------------

volatile unsigned char clock_T0 = 0, clock_10ms = 0, clock_100ms = 0;
volatile unsigned char clock_500ms = 0, clock_1s = 0;

//------------------------------- Timer 0 ------------------

			//fr 1MHh		// overflow 5ms CPU clock 1 MHZ  //204
							// and clk/256

#define T0_reload 102		// overflow 5ms 8MHz fr Zeitschleifen


//-------------------------------- Timer0 init -------------

void Timer0_init (void)     // t0_overflow = (256-T0_reload) * Period
{	
	
	//TCCR0 |= (1 << CS01) | (1 << CS00);   // set prescaler to 64 und starte Timer
	TCCR0 |= (1 << CS02);					// set prescaler to 256 und starte Timer
        

        //while ( (TIFR & (1 << TOV0) ) > 0)        // wait for overflow event
        //{
        //}
        
    TIFR &= ~(1 << TOV0);    // reset the overflow flag
	
					
  	TIMSK |= (1 << TOIE0);

}

//-------------------- Timer 0 Interrupt Servuce Routine -
ISR (TIMER0_OVF_vect)
{
	TCNT0 = T0_reload;		// Timer Count Reload 
	clock_T0++;
	sei();					
}

//------------------------------------------- main ---------
int main (void)

{ 	Application_init ();

	while (1)
	{		//-------------- Zeitscheiben ----------------

	 if (clock_T0 >= 2)
				{	clock_T0 = 0;
					clock_10ms++;
					Zeitschleife_10ms ();		//10 ms
				}
	 if (clock_10ms >= 10)
				{	clock_10ms = 0;
					clock_100ms++;
					Zeitschleife_100ms ();		//100ms
				}
	 if (clock_100ms >= 5)
				{	clock_100ms = 0;
					clock_500ms++;
					Zeitschleife_500ms ();		//500ms
				}
	 if (clock_500ms >= 2)						//1s
				{	clock_500ms = 0;
					Zeitschleife_1s ();
				}


     Zeitschleife_Idle ();						//IDLE 
	}
}  

// main Ende

